#define _GNU_SOURCE
// #include <stdio.h>
#include <string.h>
#include <dlfcn.h>
 
#define GCONFLIB "libgconf-2.so.4"

char* gconf_client_get_string(void* client, const char* key, void** err)
{
  static char* (*original_gconf_client_get_string)(void*, const char*, void**) = NULL;
  char *result;

  // printf("entering preloaded gconf...\n");
  // printf("key=[%s]\n", key ? key : "NULL");

  if (strchr(key, '+')) return NULL;

  if (!original_gconf_client_get_string) {
    void *handle = dlopen(GCONFLIB, RTLD_LAZY);
    // printf("handle=[0x%08lx]\n", (long)handle);
    if (!handle) return NULL;
    original_gconf_client_get_string = dlsym(handle, "gconf_client_get_string");
    // printf("original_gconf_client_get_string=[0x%08lx]\n", (long)original_gconf_client_get_string);
  }
  result = original_gconf_client_get_string(client, key, err);

  // printf("result=[%s]\n", result ? result : "NULL");
  // printf("exiting preloaded gconf...\n");
  return result;
}
